package org.jeecg.modules.stm.rate.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.rate.entity.RateOpt;
import org.jeecg.modules.stm.rate.service.IRateOptService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;

/**
 * @Description: rate_opt
 * @Author: jeecg-boot
 * @Date:   2023-09-26
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/rate/rateOpt")
@Slf4j
public class RateOptController extends JeecgController<RateOpt, IRateOptService> {
	@Autowired
	private IRateOptService rateOptService;
	
	/**
	 * 分页列表查询
	 *
	 * @param rateOpt
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "rate_opt-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<RateOpt>> queryPageList(RateOpt rateOpt,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<RateOpt> queryWrapper = QueryGenerator.initQueryWrapper(rateOpt, req.getParameterMap());
		Page<RateOpt> page = new Page<RateOpt>(pageNo, pageSize);
		IPage<RateOpt> pageList = rateOptService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param rateOpt
	 * @return
	 */
	@AutoLog(value = "rate_opt-添加")
	  
	//@RequiresPermissions("rate:rate_opt:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody RateOpt rateOpt) {
		rateOptService.save(rateOpt);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param rateOpt
	 * @return
	 */
	@AutoLog(value = "rate_opt-编辑")
	  
	//@RequiresPermissions("rate:rate_opt:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody RateOpt rateOpt) {
		rateOptService.updateById(rateOpt);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "rate_opt-通过id删除")
	  
	//@RequiresPermissions("rate:rate_opt:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		rateOptService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "rate_opt-批量删除")
	  
	//@RequiresPermissions("rate:rate_opt:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.rateOptService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "rate_opt-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<RateOpt> queryById(@RequestParam(name="id",required=true) String id) {
		RateOpt rateOpt = rateOptService.getById(id);
		if(rateOpt==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(rateOpt);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param rateOpt
    */
   // @RequiresPermissions("rate:rate_opt:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, RateOpt rateOpt) {
        return super.exportXls(request, rateOpt, RateOpt.class, "rate_opt");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
   // @RequiresPermissions("rate:rate_opt:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, RateOpt.class);
    }

}
